## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global debug_package %{nil}
%global __brp_strip_static_archive %{nil}
%bcond check 1

Name:           libigvm
Version:        0.3.4
Release:        %autorelease
Summary:        IGVM library

License:        MIT
URL:            https://github.com/microsoft/igvm
Source:         https://github.com/microsoft/igvm/archive/refs/tags/igvm-v%{version}.tar.gz

BuildRequires:  cargo-rpm-macros >= 24
BuildRequires:  CUnit-devel cbindgen gettext-envsubst make gcc

# All these patches are already available upstream, can be safely dropped _after_ version 0.3.4
# They bump dependencies version and fix an issue in the makefile
Patch0: 0001-zerocopy-update-from-0.7.x-to-0.8.x.-77.patch
Patch1: 0002-Add-test-for-SnpVpContext-82.patch
Patch2: 0003-repo-update-dependencies-83.patch
Patch3: 0004-igvm_c-Makefile-Fix-dependency-path-84.patch
Patch4: 0005-igvm-fix-1.86-clippy-lints-87.patch
Patch5: 0006-igvm_c-Makefile-add-two-new-external-parameters-86.patch

# Run test just when necessary. This is not upstream
Patch6: 0007-Remove-test-from-all-target.patch

%description
Igvm is an implementation of a parser for the Independent Guest Virtual Machine

%package devel
Summary:        IGVM library header files

%description devel
Contains header files for developing applications that use the %{name}

%package static
Summary:        IGVM static library files

%description static
The %{name}-static package contains libraries files for
developing applications that use %{name}

%prep
%autosetup -n igvm-igvm-v%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_license_summary
%{cargo_license} > LICENSE.dependencies

export RUSTC_BOOTSTRAP=1
export EXTRA_PARAMS="--profile rpm -Z avoid-dev-deps"
export TARGET_DIR="target"
export RELEASE=1

%make_build -C igvm_c

%if %{with check}
%check
export RUSTC_BOOTSTRAP=1
export EXTRA_PARAMS="--profile rpm -Z avoid-dev-deps"
export TARGET_DIR="target"
export RELEASE=1

%make_build -C igvm_c test
%endif

%install
export TARGET_DIR="target"
export RELEASE=1

%make_install -C igvm_c PREFIX=/usr DESTDIR=%{buildroot}

%files devel
%{_includedir}/igvm

%files static
%license LICENSE
%license LICENSE.dependencies
%doc README.md
%{_libdir}/libigvm.a
%{_libdir}/pkgconfig/igvm.pc
%{_bindir}/dump_igvm

%changelog
## START: Generated by rpmautospec
* Fri Apr 18 2025 Luigi Leonardi <leonardi@redhat.com> - 0.3.4-1
- First release of the igvm library package
## END: Generated by rpmautospec
